/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kaaproject.kaa.client.notification;

import java.io.IOException;
import java.util.List;

import org.kaaproject.kaa.common.endpoint.gen.Notification;
import org.kaaproject.kaa.common.endpoint.gen.Topic;

/**
 * Responsible for notifications' processing.
 *
 * @author Yaroslav Zeygerman
 *
 */
public interface NotificationProcessor {

    /**
     * Called on topics' list update.
     *
     * @param list the new topics' list.
     *
     */
    void topicsListUpdated(List<Topic> list);

    /**
     * Called when new notifications arrive.
     *
     * @param notifications the list of new notifications.
     *
     */
    void notificationReceived(List<Notification> notifications) throws IOException;

}
